VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} frmURSchedule 
   Caption         =   "Schedule UltraRecall Tasks"
   ClientHeight    =   4080
   ClientLeft      =   45
   ClientTop       =   345
   ClientWidth     =   5580
   OleObjectBlob   =   "frmURSchedule.frx":0000
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "frmURSchedule"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' URSchedule v1.0.0 form

Private Sub btnCancel_Click()
    Unload Me
End Sub

Private Sub btnClearOnly_Click()
    ClearURAppts
    Unload Me
End Sub

Private Sub btnNow_Click()
    Dim iInterval As Integer
    iInterval = Val(tbDuration.Text)
    tbStart.Text = Format(dtRoundUp(Now, iInterval), "General Date")
End Sub

Private Sub btnOK_Click()

    ' check to be sure clipboard contains UR grid values
    ' by seeing if first text is first column header 'Item Title'
    Dim myData As DataObject
    Set myData = New DataObject
    myData.GetFromClipboard
    If Not Left(myData.GetText(1), 10) = "Item Title" Then
        MsgBox "Clipboard does not contain valid UltraRecall task information. In Ultra Recall, make sure you select items in Search Results/Child Items pane, choose Copy Grid Values, and try again.", vbOKOnly, "Incorrect Source Data"
        GoTo TryAgain
    End If

        
    ' validate start date
    If Not IsDate(tbStart.Text) Then
        mb = MsgBox("Invalid date and time.", vbOKOnly, "Error")
        GoTo TryAgain
    End If
    
    Dim varStart As Variant
    varStart = CDate(tbStart.Text)
    
    ' determine priority
    ' olImportanceLow = 0, olImportanceNormal = 1, olImportanceHigh = 2,
    ' so use 3 to indicate Auto
    Dim iImportance As OlImportance
    iImportance = Switch(optAuto.Value, 3, optHigh.Value, olImportanceHigh, optNormal.Value, olImportanceNormal, optLow.Value, olImportanceLow)
    
    ' determine status
    ' OlBusyStatus: olFree = 0, olTentative = 1, olBusy = 2, olOutOfOffice = 3
    Dim iBusyStatus As OlBusyStatus
    iBusyStatus = Switch(optFree.Value, olFree, optTentative.Value, olTentative, optBusy.Value, olBusy, optOut.Value, olOutOfOffice)
    
    ' determine default duration
    Dim iDefaultDuration As Integer
    iDefaultDuration = Val(tbDuration.Text)
    
    ' determine valid days
    Dim abValidDays(7) As Boolean
    abValidDays(1) = cbSun.Value
    abValidDays(2) = cbMon.Value
    abValidDays(3) = cbTue.Value
    abValidDays(4) = cbWed.Value
    abValidDays(5) = cbThu.Value
    abValidDays(6) = cbFri.Value
    abValidDays(7) = cbSat.Value
   
    ' determine valid times
    Dim varBeginDay As Variant
    Dim varEndDay As Variant
    If Not IsDate(tbBegin.Text) Or Not IsDate(tbEnd.Text) Then
        mb = MsgBox("Invalid work week times.", vbOKOnly, "Error")
        GoTo TryAgain
    End If
    varBeginDay = CDate(tbBegin.Text)
    varEndDay = CDate(tbEnd.Text)
    
    ' write settings to registry
    Dim iVal As Integer
    If cbSun.Value Then iVal = 1 Else iVal = 0
    SaveSetting "URSchedule", "WorkWeek", "Sun", iVal
    If cbMon.Value Then iVal = 1 Else iVal = 0
    SaveSetting "URSchedule", "WorkWeek", "Mon", iVal
    If cbTue.Value Then iVal = 1 Else iVal = 0
    SaveSetting "URSchedule", "WorkWeek", "Tue", iVal
    If cbWed.Value Then iVal = 1 Else iVal = 0
    SaveSetting "URSchedule", "WorkWeek", "Wed", iVal
    If cbThu.Value Then iVal = 1 Else iVal = 0
    SaveSetting "URSchedule", "WorkWeek", "Thu", iVal
    If cbFri.Value Then iVal = 1 Else iVal = 0
    SaveSetting "URSchedule", "WorkWeek", "Fri", iVal
    If cbSat.Value Then iVal = 1 Else iVal = 0
    SaveSetting "URSchedule", "WorkWeek", "Sat", iVal
    
    SaveSetting "URSchedule", "WorkWeek", "Begin", tbBegin.Text
    SaveSetting "URSchedule", "WorkWeek", "End", tbEnd.Text
    SaveSetting "URSchedule", "Settings", "DefDuration", tbDuration.Text
    SaveSetting "URSchedule", "Settings", "BusyStatus", iBusyStatus
    
    ' update appointments
    If cbClearTasks.Value Then ClearURAppts
    AddURAppts varStart, iImportance, iBusyStatus, iDefaultDuration, abValidDays, varBeginDay, varEndDay
    Unload Me

TryAgain:
End Sub


Private Sub spin12HR_SpinDown()
    SpinStart "h", -12
End Sub

Private Sub spin12HR_SpinUp()
    SpinStart "h", 12
End Sub

Private Sub spin1HR_SpinDown()
    SpinStart "h", -1
End Sub

Private Sub spin1HR_SpinUp()
    SpinStart "h", 1
End Sub

Private Sub spin15MIN_SpinDown()
    SpinStart "n", -15
End Sub

Private Sub spin15MIN_SpinUp()
    SpinStart "n", 15
End Sub


Private Sub SpinStart(strInterval As String, dblIncr As Double)
    ' validate start date
    If Not IsDate(tbStart.Text) Then
        mb = MsgBox("Invalid date and time.", vbOKOnly, "Error")
        GoTo TryAgain
    End If
    
    Dim varStart As Variant
    varStart = CDate(tbStart.Text)
    varStart = DateAdd(strInterval, dblIncr, varStart)
    tbStart.Text = Format(varStart, "m/d/yy h:mm AMPM")
    
TryAgain:
End Sub

Private Sub UserForm_Initialize()

    ' setup the start date
    tbStart.Text = Format(dtRoundUp(Now, 15), "m/d/yy h:mm AMPM")
    
    ' setup work week (get data from registry)
    cbSun.Value = (GetSetting("URSchedule", "WorkWeek", "Sun", 1) = 1)
    cbMon.Value = (GetSetting("URSchedule", "WorkWeek", "Mon", 1) = 1)
    cbTue.Value = (GetSetting("URSchedule", "WorkWeek", "Tue", 1) = 1)
    cbWed.Value = (GetSetting("URSchedule", "WorkWeek", "Wed", 1) = 1)
    cbThu.Value = (GetSetting("URSchedule", "WorkWeek", "Thu", 1) = 1)
    cbFri.Value = (GetSetting("URSchedule", "WorkWeek", "Fri", 1) = 1)
    cbSat.Value = (GetSetting("URSchedule", "WorkWeek", "Sat", 1) = 1)
    tbBegin.Text = GetSetting("URSchedule", "WorkWeek", "Begin", "9:00 AM")
    tbEnd.Text = GetSetting("URSchedule", "WorkWeek", "End", "5:00 PM")
    
    ' setup default duration
    tbDuration.Text = GetSetting("URSchedule", "Settings", "DefDuration", "15")
    
    ' setup status
    Select Case GetSetting("URSchedule", "Settings", "BusyStatus", olTentative)
    Case olFree
        optFree.Value = True
    Case olTentative
        optTentative.Value = True
    Case olBusy
        optBusy.Value = True
    Case olOutOfOffice
        optOut.Value = True
    End Select
        
End Sub
